<?php
//CHARTBOOST API REVENUE EMAIL by Jeff Sherk

//For each $chartboost_user enter new item as array('user_id', 'user_signature', 'email address where to send report')
//Get user_id and user_signature from MANAGE ACCOUNT > API DETAILS

$chartboost_user[0] = array('123456789012345678901234', '1234567890123456789012345678901234567890', 'me@mydomain.com');
//$chartboost_user[1] = array('123456789012345678901234', '1234567890123456789012345678901234567890', 'me@mydomain.com'); //add as many different accounts as you want
//$chartboost_user[2] = array('123456789012345678901234', '1234567890123456789012345678901234567890', 'me@mydomain.com'); //add as many different accounts as you want


$yesterday = date('Y-m-d', time() - 60 * 60 * 24); //In order to get yesterdays analytics run cron AFTER midnight Pacific time (I use 6am)

foreach ($chartboost_user as $cb_user) {

    $get_page = file_get_contents('http://api.chartboost.com/analytics/apps?date_min='.$yesterday.'&date_max='.$yesterday.'&group_by=app&aggregate=daily&user_id='.$cb_user[0].'&user_signature='.$cb_user[1]);

    $decoded_page = json_decode($get_page, true);

    sortArrayBySubKey($decoded_page, "App Name");

    $decoded_error_message = "";
    if ( array_key_exists("status", $decoded_page) ) {
        $decoded_error_message = $decoded_page['status'];
    }
    if ( array_key_exists("message", $decoded_page) ) {
        $decoded_error_message .= " : ".$decoded_page['message'];
    }

    $impressions = 0;
    $revenue = 0;

    unset($app); //make sure array is reset for each cb account
    $app[0] = '<b><font color="red">Chartboost App Analytics for '.$yesterday.'</font></b><br>';
    $app[1] = '';

    foreach ($decoded_page as $app_data) {

        $app[] = '<b>' . $app_data['App Name'] . '</b> - Downloads=' . $app_data['All Installs'] . '<br>Impressions=' . $app_data['Impressions Delivered'] . ' - Delivered Installs=' . $app_data['Installs Delivered'] . ' - eCPM=' . $app_data['eCPM Earned'] . ' - <b>Revenue=' . $app_data['Money Earned'] . '</b><br><br>';

        $temp = str_replace(",", "", $app_data['Impressions Delivered']); //strip out commas
        $impressions += $temp;

        $temp = str_replace(",", "", $app_data['Money Earned']); //strip out commas
        $temp = str_replace("$", "", $temp); //strip out dollar sign
        $revenue += $temp;

    }
    
    if ($impressions == 0) {
        $ecpm = 0;
    } else {
        $ecpm = ($revenue / $impressions) * 1000;
    }

    $app[1] = 'eCPM=$'.$ecpm.' - Total Revenue=$'.$revenue.'<br><br>';

    $email = '';
    
    if ( $decoded_error_message != "" ) {

        $email = $decoded_error_message;

    } else {

        foreach ($app as $data) {
            $email .= $data;
        }

    }

    $headers .= "MIME-Version: 1.0\r\n";
    $headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";
    mail($cb_user[2], 'Chartboost revenue report', $email, $headers); //need headers to send HTML email
    //echo $email.'<br><br><br>'; //debug display to screen

}

//This function will sort the array of all app data alphabetically by APP NAME
function sortArrayBySubKey (&$array, $key) {
    $sorter=array();
    $ret=array();
    reset($array);
    foreach ($array as $ii => $va) {
        $sorter[$ii]=$va[$key];
    }
    asort($sorter);
    foreach ($sorter as $ii => $va) {
        $ret[$ii]=$array[$ii];
    }
    $array=$ret;
}

?>

